BEGIN {
	sch_copy=1
	insch=0
	mod_comps = 0
	sch_comps = 0
}

############################### modifier part ################################

($0 == sep) {
	insch=1
	refdes=""
	next
}

/^component / {
	refdes=$3
	REFDES[mod_comps] = refdes
	mod_comps++
}

/^ attr/ {
	attr=$2
	$1=""
	$2=""
	val = $0
	sub("^ *", "", val)
	ASUBST[refdes, attr] = val
}

/^ pin/ {
	pin=$2
	attr=$3
	$1=""
	$2=""
	$3=""
	val = $0
	sub("^ *", "", val)
	PSUBST[refdes, pin, attr] = val
}

# don't let sch.awk run before we are past the modifier part
(!insch) { next }

################################ sch part ###################################

/^[ \t]*$/ { next }

/^source=/ {
	src=$0
	sub("^source=", "", src)
	if (ASUBST[refdes, "source"] == src) {
		src = path_lookup(src, basedir, "source-library");
		dst = path_prefix_basename(src, "DEVMAP.", "./")
		if (!(src in DEVMAPPED)) {
			DEVMAPPED[src] = 1
			system(devmap_script " --recurse " src " " dst " >&2");
			if (dellist != "")
				print dst >> dellist
		}
		sub("^" tmpdir, "", dst)
		print "source=" dst
	}
	else
		print "irrelevant_" $0
	next
}

function sch_comp_start()
{
	refdes = REFDES[sch_comps]
	sch_comps++
}

function sch_sym_attr(key, val)
{
}

function sch_instance_attr(key, val)
{
	if (key == "source") {
		print "old_source=" val
		return 1
	}
	idx = refdes SUBSEP key
	ATTR_SEEN[key] = 1
	if ((idx in ASUBST) && (ASUBST[idx] != val)) {
#		print "#@A " refdes "/" key " = " ASUBST[idx] " !! " val > "/dev/stderr"
		print key "=" ASUBST[idx]
		return 1
	}
}

function sch_comp_end()
{
# check if all pin attributes in ASUBST has been used - if not, add as new
# attributes
	prefix = "^" refdes SUBSEP
	for(n in ASUBST) {
		if (n ~ prefix) {
			sub(prefix, "", n)
			if (!(n in ATTR_SEEN)) {
				if (n != "source") {
					print "T 47850 48150 5 8 0 1 0 0 1"
					print n "=" ASUBST[refdes,n]
				}
			}
		}
	}
	delete ATTR_SEEN
}


function sch_pin_start()
{
}

function sch_pin_attr(key, val)
{
	idx = refdes SUBSEP inpin SUBSEP key
	PIN_SEEN[key] = 1
	if ((idx in PSUBST) && (PSUBST[idx] != val)) {
#		print "#@P " refdes "/" inpin "/" key " = " PSUBST[idx] " !! " val > "/dev/stderr"
		print key "=" PSUBST[idx]
		return 1
	}
}

function sch_pin_end(        n,prefix)
{
# check if all pin attributes in PSUBST has been used - if not, add as new
# attributes
	prefix = "^" refdes SUBSEP inpin SUBSEP
	for(n in PSUBST) {
		if (n ~ prefix) {
			sub(prefix, "", n)
			if (!(n in PIN_SEEN)) {
				print "T 47850 48150 5 8 0 1 0 0 1"
				print n "=" PSUBST[refdes,inpin,n]
			}
		}
	}
	delete PIN_SEEN
}
